# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class ContestDataPrizes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        ContestDataPrizes - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tier': 'int',
            'name': 'str',
            'image_id': 'str'
        }

        self.attribute_map = {
            'tier': 'tier',
            'name': 'name',
            'image_id': 'imageId'
        }

        self._tier = None
        self._name = None
        self._image_id = None

    @property
    def tier(self) -> int:
        """
        Gets the tier of this ContestDataPrizes.
        Tier of the prize

        :return: The tier of this ContestDataPrizes.
        :rtype: int
        """
        return self._tier

    @tier.setter
    def tier(self, tier: int) -> None:
        """
        Sets the tier of this ContestDataPrizes.
        Tier of the prize

        :param tier: The tier of this ContestDataPrizes.
        :type: int
        """
        

        self._tier = tier

    @property
    def name(self) -> str:
        """
        Gets the name of this ContestDataPrizes.
        Name of the prize

        :return: The name of this ContestDataPrizes.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this ContestDataPrizes.
        Name of the prize

        :param name: The name of this ContestDataPrizes.
        :type: str
        """
        

        self._name = name

    @property
    def image_id(self) -> str:
        """
        Gets the image_id of this ContestDataPrizes.
        Id of the prize image

        :return: The image_id of this ContestDataPrizes.
        :rtype: str
        """
        return self._image_id

    @image_id.setter
    def image_id(self, image_id: str) -> None:
        """
        Sets the image_id of this ContestDataPrizes.
        Id of the prize image

        :param image_id: The image_id of this ContestDataPrizes.
        :type: str
        """
        

        self._image_id = image_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

