# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import AddressableEntityRef

class TestTopicPhraseJobs(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        TestTopicPhraseJobs - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'state': 'str',
            'created_by': 'AddressableEntityRef',
            'date_created': 'datetime',
            'date_modified': 'datetime',
            'action': 'str',
            'entity_type': 'str',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'state': 'state',
            'created_by': 'createdBy',
            'date_created': 'dateCreated',
            'date_modified': 'dateModified',
            'action': 'action',
            'entity_type': 'entityType',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._state = None
        self._created_by = None
        self._date_created = None
        self._date_modified = None
        self._action = None
        self._entity_type = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this TestTopicPhraseJobs.
        The globally unique identifier for the object.

        :return: The id of this TestTopicPhraseJobs.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this TestTopicPhraseJobs.
        The globally unique identifier for the object.

        :param id: The id of this TestTopicPhraseJobs.
        :type: str
        """
        

        self._id = id

    @property
    def state(self) -> str:
        """
        Gets the state of this TestTopicPhraseJobs.


        :return: The state of this TestTopicPhraseJobs.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state: str) -> None:
        """
        Sets the state of this TestTopicPhraseJobs.


        :param state: The state of this TestTopicPhraseJobs.
        :type: str
        """
        if isinstance(state, int):
            state = str(state)
        allowed_values = ["Running", "Completed", "Failed"]
        if state.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for state -> " + state)
            self._state = "outdated_sdk_version"
        else:
            self._state = state

    @property
    def created_by(self) -> 'AddressableEntityRef':
        """
        Gets the created_by of this TestTopicPhraseJobs.


        :return: The created_by of this TestTopicPhraseJobs.
        :rtype: AddressableEntityRef
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by: 'AddressableEntityRef') -> None:
        """
        Sets the created_by of this TestTopicPhraseJobs.


        :param created_by: The created_by of this TestTopicPhraseJobs.
        :type: AddressableEntityRef
        """
        

        self._created_by = created_by

    @property
    def date_created(self) -> datetime:
        """
        Gets the date_created of this TestTopicPhraseJobs.
        Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :return: The date_created of this TestTopicPhraseJobs.
        :rtype: datetime
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created: datetime) -> None:
        """
        Sets the date_created of this TestTopicPhraseJobs.
        Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :param date_created: The date_created of this TestTopicPhraseJobs.
        :type: datetime
        """
        

        self._date_created = date_created

    @property
    def date_modified(self) -> datetime:
        """
        Gets the date_modified of this TestTopicPhraseJobs.
        Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :return: The date_modified of this TestTopicPhraseJobs.
        :rtype: datetime
        """
        return self._date_modified

    @date_modified.setter
    def date_modified(self, date_modified: datetime) -> None:
        """
        Sets the date_modified of this TestTopicPhraseJobs.
        Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :param date_modified: The date_modified of this TestTopicPhraseJobs.
        :type: datetime
        """
        

        self._date_modified = date_modified

    @property
    def action(self) -> str:
        """
        Gets the action of this TestTopicPhraseJobs.


        :return: The action of this TestTopicPhraseJobs.
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action: str) -> None:
        """
        Sets the action of this TestTopicPhraseJobs.


        :param action: The action of this TestTopicPhraseJobs.
        :type: str
        """
        

        self._action = action

    @property
    def entity_type(self) -> str:
        """
        Gets the entity_type of this TestTopicPhraseJobs.


        :return: The entity_type of this TestTopicPhraseJobs.
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type: str) -> None:
        """
        Sets the entity_type of this TestTopicPhraseJobs.


        :param entity_type: The entity_type of this TestTopicPhraseJobs.
        :type: str
        """
        if isinstance(entity_type, int):
            entity_type = str(entity_type)
        allowed_values = ["TOPIC", "PROGRAM", "PROGRAM_TOPIC_LINK", "TOPIC_PHRASE"]
        if entity_type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for entity_type -> " + entity_type)
            self._entity_type = "outdated_sdk_version"
        else:
            self._entity_type = entity_type

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this TestTopicPhraseJobs.
        The URI for this object

        :return: The self_uri of this TestTopicPhraseJobs.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this TestTopicPhraseJobs.
        The URI for this object

        :param self_uri: The self_uri of this TestTopicPhraseJobs.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

